divert(-1)
#
# copymail hack, addition to sendmail
# developed by Thom O'Connor and Ken Bolingbroke, Sendmail, Inc., 3/11/99
# modified by Thom O'Connor, 8/12/99
#
divert(0)
VERSIONID(`@(#)copymail.m4   8.9.3 8/12/99')
divert(-1)

LOCAL_CONFIG
# replace the word "copyuser" with the actual user
# who will be receiving the copied mail
D{copymail}copyuser@example.com

# replace the word "COPY" with whatever text you want attached to a user's
# email address to force the copy
D{copytext}COPY

# add ${copytext} to class P, which will prevent DNS lookups on that extension
CP${copytext}

# custom map file which does lookups based on domain
Kcopymail hash -o /etc/mail/copymailtable
#              ^^ WARNING: might be silently ignored!

LOCAL_RULE_0
R$*					$: $> Copymail $1

LOCAL_RULESETS
SCopymail
# check that a remote host did not attempt to circumvent the copymail process
# ca: removed '_' in name: if '_' in in OperatorChars, you have to quote it.
R$* < @ $* . ${copytext} . > $*		$: $> CopymailRelayCheck $1 < @ $2 . ${copytext} . > $3
R$* . ${copytext}			$: $> CopymailRelayCheck $1 . ${copytext} 
# remove ${copytext} and escape the ruleset if already processed
R$* < @ $* . ${copytext} . > $*		$@ $1 < @ $2 . > $3
R$* ${copytext} $*			$@ $1 $2

# catch mail sent to the copyuser
R$*				$: $1 $| $>4 $1		rewrite back to original form
R$* $| ${copymail} $*		$@ $1			check to see if recipient is copymail user
R$* $| $*			$: $1
R${copymail} $*			$@ ${copymail} $1

# copymail map lookup
# ca: you may run into a problem here if the hostname lookup didn't succeed
# ca: that is, it only works on system with DNS
R$*				$: <@> $1
R<@> $* < @ $+ . > $*		$: < $2 > $1 < @ $2 . > $3	extract host name
R<@> $*				$: < $j > $1 < @ $j . >		local user (no domain)
R< $+ > $*			$: $2 $| <?> $(copymail $1 $: ${copymail} $)	perform lookup
R$* $| <?> $*			$: $1 $| $>3 $2		get back to regular format
R$* < @ $* . > $* $| $* < @ $* . >	$#copymail $@ localhost $: $1 < @ $2 . ${copytext} > $3 , $4 < @ $5 . ${copytext} . >
R$* $| $* < @ $* . >		$#copymail $@ localhost $: $1 . ${copytext} , $2 < @ $3 . ${copytext} . >

# force failure if copymail did not succeed
R$*				$#error $@ 5.7.1 $: "550 Mail archive failure"

SCopymailRelayCheck
# check that ${copytext} was added by the local host only
# ca: dequote not necessary in 8.9
R$*				$: $1 $| <?> $&{client_addr}
R$* $| <?> $+			$#error $@ 5.7.1 $: "550 Invalid recipient address"
R$* $| $*			$@ $1

MAILER_DEFINITIONS
# for UNIX, "P=/usr/sbin/sendmail"
# or "P=/usr/lib/sendmail"
# for NT, "P=sendmail.exe"
Mcopymail, P=/usr/sbin/sendmail, F=fmSDFMu, S=11/31, R=21/31,
	A=sendmail $u

